	.area text(rom,rel)
	.dbfile ..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\icctest\interrupts\interrupt.c
	.area data(ram,rel)
	.dbfile ..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\icctest\interrupts\interrupt.c
	.align	4
_IntArray::
	.long -1598281744
	.long -1598281232
	.long -2130958332
	.long -1598280720
	.long -2130957816
	.long -1598280208
	.long -2130957300
	.long 146547221
	.long 1690299409
	.long 146547734
	.long 146546708
	.long -1598282766
	.long 1824268818
	.long 1656496656
	.long 135537171
	.long 1551630346
	.long 1678559028
	.long 1105999400
	.long 84557874
	.long -315189182
	.long 12833
	.long 112
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\interrupts\IntArray.h
	.dbsym e IntArray _IntArray A[88:22]L
	.area text(rom,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\interrupts\IntArray.h
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\interrupts\interrupt.c
	.dbfunc e int_interrupt _int_interrupt fV
_int_interrupt::
	.dbline -1
	.dbline 15
; /**
;  * @file interrupt.c
;  * Defines ICCPROP kernel interrupt interface
;  */
; #include "interrupt.h"
; #include "IntArray.h"
; 
; /*
;  * This is the first level interrupt handler.
;  * It calls the user handler registered during init after disabling interrupts.
;  * It re-enables global interrupts before function return.
;  * Adding variables to this function will break the system.
;  */
; void int_interrupt(void)
; {
	.dbline 16
;     user_handler();
	@FCALL	
	.long _user_handler	
	.dbline -2
L1:
	@FRET	
	.dbline 0 ; func end
	.dbend
	.dbfunc e int_initialize _int_initialize fV
	.dbstruct 0 16 hwint_struct
	.dbfield 0 isr L
	.dbfield 4 imr L
	.dbfield 8 pins L
	.dbfield 12 invt L
	.dbend
;           usr3 -> R5
;           usr2 -> R4
;            hwp -> R0
_int_initialize::
	@FENTER	
	.long R4,R5,R15,0	
	.dbline -1
	.dbline 26
; }
; 
; /*
;  * Initialize interrupt subsystem to known disabled state.
;  * Set first level handler in kernel, and set user handler.
;  * This function will not enable interrupts.
;  * See header for more details.
;  */
; void int_initialize(hwint_t* hwp)
; {
	.dbline 27
;     int usr2 = (int)&int_interrupt; // first level interrupt handler
	@FLOAD	
	.long _int_interrupt	
	mov R4,TEMP0	
	.dbline 28
;     int usr3 = (int)&hwp->isr;      // hw isr address pointer
	mov R5,R0	
	.dbline 29
;     asm("mov USER0, #0");           // disable interrupts
	mov USER0, #0
	.dbline 30
;     asm("mov USER1, #0");           // clear "vector"
	mov USER1, #0
	.dbline 31
;     asm("mov USER2, %usr2");        // set first level interrupt handler
	mov USER2, R4
	.dbline 32
;     asm("mov USER3, %usr3");        // set isr address pointer
	mov USER3, R5
	.dbline 33
;     asm("mov USER4, #0");           // clear isr contents register
	mov USER4, #0
	.dbline -2
L2:
	@FPOP	
	.long R15,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r usr3 5 I
	.dbsym r usr2 4 I
	.dbsym r hwp 0 pS[hwint_struct]
	.dbend
	.dbfunc e int_pause _int_pause fV
;           time -> R4
;            per -> R0
_int_pause::
	@FENTER	
	.long R4,0	
	.dbline -1
	.dbline 44
;     // let user enable interrupts
; }
; 
; /*
;  * delay function used after start cog and during screen updates
;  * @param per is number of ticks to wait ....
;  * Careful, if per is too small, the processor will wait until the next count
;  * which can be on the order of minutes.
;  */
; void int_pause(int per)
; {
	.dbline 45
;     int time = 0;
	mov R4,#0	
	.dbline 46
;     asm("mov        %time, cnt");
	mov        R4, cnt
	.dbline 47
;     asm("add        %time, %per");
	add        R4, R0
	.dbline 48
;     asm("waitcnt    %time, %per");
	waitcnt    R4, R0
	.dbline -2
L3:
	@FPOP	
	.long R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r time 4 I
	.dbsym r per 0 I
	.dbend
	.dbfunc e int_start _int_start fI
;             id -> R4
;            hwp -> R5
_int_start::
	@FENTER	
	.long R4,R5,R15,0	
	mov R5,R0	
	.dbline -1
	.dbline 56
; }
; 
; /*
;  * Start the hardware interrupt monitor COG.
;  * See header for more details.
;  */
; int int_start(hwint_t* hwp)
; {
	.dbline 57
;     int id = 0;
	.dbline 58
;     int_initialize(hwp);
	mov R0,R5	
	@FCALL	
	.long _int_initialize	
	.dbline 59
;     id = cognewNative(IntArray, hwp);
	@FLOAD	
	.long _IntArray	
	mov R0,TEMP0	
	mov R1,R5	
	@FCALL	
	.long _cognewNative	
	mov R4,R0	
	.dbline 60
;     int_pause(10000000); // wait for driver to start
	@FLOAD	
	.long 10000000	
	mov R0,TEMP0	
	@FCALL	
	.long _int_pause	
	.dbline 61
;     return id;
	mov R0,R4	
	.dbline -2
L4:
	@FPOP	
	.long R15,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r id 4 I
	.dbsym r hwp 5 pS[hwint_struct]
	.dbend
	.dbfunc e int_stop _int_stop fV
;             id -> R0
_int_stop::
	.dbline -1
	.dbline 69
; }
; 
; /*
;  * Stop hardware interrupt monitor cog
;  * See header file for more details.
;  */
; void int_stop(int id)
; {
	.dbline 70
;     if(id) {
	cmp R0,#0	WZ
IF_E	add PC,#4	
	.dbline 70
	.dbline 71
;         asm("cogstop %id");
	cogstop R0
	.dbline 72
;     }
L6:
	.dbline -2
L5:
	@FRET	
	.dbline 0 ; func end
	.dbsym r id 0 I
	.dbend
	.dbfunc e int_getVector _int_getVector fi
;             rc -> R1
_int_getVector::
	.dbline -1
	.dbline 80
; }
; 
; /*
;  * Gets the vector. Called at interrupt time.
;  * See header for more details.
;  */
; size_t int_getVector(void)
; {
	.dbline 82
;     size_t rc;
;     asm("mov %rc, USER1");
	mov R1, USER1
	.dbline 83
;     return rc;
	mov R0,R1	
	.dbline -2
L8:
	@FRET	
	.dbline 0 ; func end
	.dbsym r rc 1 i
	.dbend
	.dbfunc e int_setVector _int_setVector fV
;             rc -> R4
;        handler -> R0
_int_setVector::
	@FENTER	
	.long R4,0	
	.dbline -1
	.dbline 91
; }
; 
; /*
;  * Sets the vector. Called at interrupt time.
;  * See header for more details.
;  */
; void int_setVector(size_t handler)
; {
	.dbline 92
;     size_t rc = handler;
	mov R4,R0	
	.dbline 93
;     asm("mov USER1,%rc");
	mov USER1,R4
	.dbline -2
L9:
	@FPOP	
	.long R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r rc 4 i
	.dbsym r handler 0 i
	.dbend
	.dbfunc e enable _enable fV
_enable::
	.dbline -1
	.dbline 100
; }
; 
; /*
;  * enable all interrupts
;  */
; void enable(void)
; {
	.dbline 101
;     asm("mov USER0, #1");
	mov USER0, #1
	.dbline -2
L10:
	@FRET	
	.dbline 0 ; func end
	.dbend
	.dbfunc e disable _disable fV
_disable::
	.dbline -1
	.dbline 108
; }
; 
; /*
;  * disable all interrupts
;  */
; void disable(void)
; {
	.dbline 109
;     asm("mov USER0, #0");
	mov USER0, #0
	.dbline -2
L11:
	@FRET	
	.dbline 0 ; func end
	.dbend
